SystemOrganization addCategory: #ZincHTTPLoggingGemStone!

Announcement subclass: #ZnLogEvent
	instanceVariableNames: 'timestamp id'
	classVariableNames: 'IdCounter LogEventAnnouncer'
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnLogEvent commentStamp: 'SvenVanCaekenberghe 6/11/2014 14:20' prior: 0!
I am ZnLogEvent, the base class of a log events emitted by elements of the Zinc HTTP Components framework.

I add a timestamp and a simple id attribute. The id can wrap around and should only be used to distinguish between events that have the same timestamp.

ZnLogEvents are distributed as Announcement through a singleton Announcer that I maintain.

I have a small convenience API to log to the Transcript or open a simple GUI on the emitted log events.!

ZnLogEvent subclass: #ZnClientLogEvent
	instanceVariableNames: 'clientId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnClientLogEvent commentStamp: 'SvenVanCaekenberghe 6/12/2014 15:25' prior: 0!
I am ZnClientLogEvent, a ZnLogEvent generated by ZnClient.

I hold an optional clientId attribute.
!

ZnClientLogEvent subclass: #ZnClientConnectionClosedEvent
	instanceVariableNames: 'address port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnClientConnectionClosedEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 13:58' prior: 0!
ZnClientConnectionClosedEvent signals that a client side connection to address:port is closed.!

!ZnClientConnectionClosedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 16:49'!
address
	^ address! !

!ZnClientConnectionClosedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 16:49'!
address: anObject
	address := anObject! !

!ZnClientConnectionClosedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 16:57'!
port
	^ port! !

!ZnClientConnectionClosedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 16:57'!
port: anObject
	port := anObject! !

!ZnClientConnectionClosedEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Connection Closed '.
	address do: [ :each | stream print: each ] separatedBy: [ stream nextPut: $. ].
	stream nextPut: $:; print: port! !

ZnClientLogEvent subclass: #ZnClientFollowingRedirectEvent
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnClientFollowingRedirectEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 14:34' prior: 0!
ZnClientFollowingRedirectEvent signals that a redirect to target is being followed. How many redirects to follow, if any is configurable.!

!ZnClientFollowingRedirectEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Following Redirect '; print: target! !

!ZnClientFollowingRedirectEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:46'!
target
	^ target! !

!ZnClientFollowingRedirectEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:46'!
target: anObject
	target := anObject! !

ZnClientLogEvent subclass: #ZnClientIgnoringExceptionOnConnectionReuseEvent
	instanceVariableNames: 'exception'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnClientIgnoringExceptionOnConnectionReuseEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 14:00' prior: 0!
ZnClientIgnoringExceptionOnConnectionReuseEvent signals that a client connection was reused and that an exception occurred. Normally, there is one retry after that, trying to reconnect.
!

!ZnClientIgnoringExceptionOnConnectionReuseEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:47'!
exception
	^ exception! !

!ZnClientIgnoringExceptionOnConnectionReuseEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:47'!
exception: anObject
	exception := anObject! !

!ZnClientIgnoringExceptionOnConnectionReuseEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Ignoring Exception On Connection Reuse '; print: exception! !

!ZnClientLogEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:13'!
clientId
	^ clientId! !

!ZnClientLogEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:13'!
clientId: anObject
	clientId := anObject! !

!ZnClientLogEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 11/6/2014 15:30'!
printContentsOn: stream
	super printContentsOn: stream.
	clientId ifNotNil: [ stream space; << clientId ]! !

ZnClientLogEvent subclass: #ZnClientRetryingEvent
	instanceVariableNames: 'exception'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnClientRetryingEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 14:01' prior: 0!
ZnClientRetryingEvent signals a client is retrying is main operation. The number of retries is configurable.
!

!ZnClientRetryingEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:47'!
exception
	^ exception! !

!ZnClientRetryingEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:47'!
exception: anObject
	exception := anObject! !

!ZnClientRetryingEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Retrying '; print: exception! !

ZnClientLogEvent subclass: #ZnClientTransactionEvent
	instanceVariableNames: 'request response requestDuration responseDuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnClientTransactionEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 14:09' prior: 0!
ZnClientTransactionEvent is a ZnClientLogEvent that notes the completion of a client side HTTP transaction (request/response).

Instance Variables
	request: a ZnRequest
	requestDuration:	 milliseconds
	response:	a ZnResponse
	responseDuration: milliseconds
	
Note that this can be quite large since it includes the entities transferred. See ZnSimplifiedClientTransactionEvent for a more compact representation.!

!ZnClientTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/12/2014 14:12'!
duration
	^ requestDuration + responseDuration! !

!ZnClientTransactionEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream space.
	request requestLine printMethodAndUriOn: stream.
	stream space; print: response code.
	response hasEntity
		ifTrue: [ 
			stream space; print: response entity contentLength; nextPut: $B ].
	stream space; print: self duration; nextPutAll: 'ms'! !

!ZnClientTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 16:23'!
request
	^ request! !

!ZnClientTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 16:23'!
request: anObject
	request := anObject! !

!ZnClientTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/12/2014 14:12'!
requestDuration
	^ requestDuration! !

!ZnClientTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/12/2014 14:12'!
requestDuration: anObject
	requestDuration := anObject! !

!ZnClientTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 16:23'!
response
	^ response! !

!ZnClientTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 16:23'!
response: anObject
	response := anObject! !

!ZnClientTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/12/2014 14:12'!
responseDuration
	^ responseDuration! !

!ZnClientTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/12/2014 14:12'!
responseDuration: anObject
	responseDuration := anObject! !

ZnClientLogEvent subclass: #ZnConnectionEstablishedEvent
	instanceVariableNames: 'hostname port address duration proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnConnectionEstablishedEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 14:35' prior: 0!
ZnConnectionEstablishedEvent signals that a client HTTP connection to hostname:port (address:port) was established in duration milliseconds. This time includes DNS resolving.!

!ZnConnectionEstablishedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:59'!
address
	^ address! !

!ZnConnectionEstablishedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:59'!
address: anObject
	address := anObject! !

!ZnConnectionEstablishedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:59'!
duration
	^ duration! !

!ZnConnectionEstablishedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:59'!
duration: anObject
	duration := anObject! !

!ZnConnectionEstablishedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:59'!
hostname
	^ hostname! !

!ZnConnectionEstablishedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:59'!
hostname: anObject
	hostname := anObject! !

!ZnConnectionEstablishedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:59'!
port
	^ port! !

!ZnConnectionEstablishedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:59'!
port: anObject
	port := anObject! !

!ZnConnectionEstablishedEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 10/23/2015 16:40'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Connection Established '; nextPutAll: hostname; nextPut: $:; print: port; space. 
	proxy ifNotNil: [ stream << 'via proxy '; print: proxy; space ].
	address do: [ :each | stream print: each ] separatedBy: [ stream nextPut: $. ].
	stream space; print: duration; << 'ms '.! !

!ZnConnectionEstablishedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 10/23/2015 16:34'!
proxy
	^ proxy! !

!ZnConnectionEstablishedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 10/23/2015 16:34'!
proxy: anObject
	proxy := anObject! !

ZnClientLogEvent subclass: #ZnRequestWrittenEvent
	instanceVariableNames: 'request duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnRequestWrittenEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 14:05' prior: 0!
ZnRequestWrittenEvent signals that a request was written in duration milliseconds.!

!ZnRequestWrittenEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 16:23'!
duration
	^ duration! !

!ZnRequestWrittenEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 16:23'!
duration: anObject
	duration := anObject! !

!ZnRequestWrittenEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Request Written '; print: request; space; print: duration; << 'ms'! !

!ZnRequestWrittenEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 16:23'!
request
	^ request! !

!ZnRequestWrittenEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 16:23'!
request: anObject
	request := anObject! !

ZnClientLogEvent subclass: #ZnResponseReadEvent
	instanceVariableNames: 'response duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnResponseReadEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 14:06' prior: 0!
ZnResponseReadEvent signals that a response was read in duration milliseconds. This time includes all waiting, server processing and networking.!

!ZnResponseReadEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 16:23'!
duration
	^ duration! !

!ZnResponseReadEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 16:23'!
duration: anObject
	duration := anObject! !

!ZnResponseReadEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Response Read '; print: response; space; print: duration; << 'ms'! !

!ZnResponseReadEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 16:23'!
response
	^ response! !

!ZnResponseReadEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 16:23'!
response: anObject
	response := anObject! !

ZnClientLogEvent subclass: #ZnSimplifiedClientTransactionEvent
	instanceVariableNames: 'method url response size duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnSimplifiedClientTransactionEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 15:18' prior: 0!
ZnSimplifiedClientTransactionEvent is a ZnClientLogEvent that notes the completion of a client side HTTP transaction (request/response). Only a limited number of simpler data is held. ZnClientTransactionEvent contains much more detailed data.

Instance Variables
	method: HTTP verb
	url: ZnUrl requested
	response:	numeric response code
	size: number of bytes in response
	duration: milliseconds

ZnSimplifiedClientTransactionEvent is ideal for classic HTTP logging with little overhead through its default string representation.!

!ZnSimplifiedClientTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/12/2014 19:38'!
duration
	^ duration! !

!ZnSimplifiedClientTransactionEvent methodsFor: 'initialize' stamp: 'SvenVanCaekenberghe 6/12/2014 19:37'!
initialize
	super initialize.
	duration := 0! !

!ZnSimplifiedClientTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/12/2014 19:38'!
method
	^ method! !

!ZnSimplifiedClientTransactionEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream space; nextPutAll: method.
	stream space.
	url printPathQueryFragmentOn: stream.
	stream space; print: response.
	size ifNotNil: [ 
		stream space; print: size; nextPut: $B ].
	stream space; print: duration; nextPutAll: 'ms'! !

!ZnSimplifiedClientTransactionEvent methodsFor: 'initialize' stamp: 'SvenVanCaekenberghe 6/12/2014 19:40'!
request: aZnRequest
	method := aZnRequest method.
	url := aZnRequest url! !

!ZnSimplifiedClientTransactionEvent methodsFor: 'initialize' stamp: 'SvenVanCaekenberghe 6/12/2014 19:41'!
requestDuration: requestDuration
	duration := duration + requestDuration ! !

!ZnSimplifiedClientTransactionEvent methodsFor: 'initialize' stamp: 'SvenVanCaekenberghe 6/12/2014 19:44'!
response: aZnResponse
	response := aZnResponse code.
	aZnResponse hasEntity
		ifTrue: [ size := aZnResponse entity contentLength ]! !

!ZnSimplifiedClientTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/12/2014 19:39'!
responseCode
	^ response! !

!ZnSimplifiedClientTransactionEvent methodsFor: 'initialize' stamp: 'SvenVanCaekenberghe 6/12/2014 19:41'!
responseDuration: responseDuration
	duration := duration + responseDuration ! !

!ZnSimplifiedClientTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:06'!
size
	^ size! !

!ZnSimplifiedClientTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/12/2014 19:38'!
url
	^ url! !

!ZnLogEvent class methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 13:58'!
announcer
	^ LogEventAnnouncer ifNil: [ LogEventAnnouncer := Announcer new ]! !

!ZnLogEvent class methodsFor: 'class initialization' stamp: 'PaulDeBruicker 11/24/2016 15:38'!
initialize
	IdCounter := 0.
 Smalltalk addToStartUpList: self ! !

ZnLogEvent initialize!

!ZnLogEvent class methodsFor: 'convenience' stamp: 'SvenVanCaekenberghe 2/11/2015 15:23'!
logToTranscript
	self stopLoggingToTranscript.
	^ self announcer when: ZnLogEvent do: [ :event | Transcript crShow: event ].! !

!ZnLogEvent class methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 13:57'!
nextId
	"This should be thread safe because SmallInteger 
	arithmetic primitives cannot be interrupted"
	
	^ IdCounter := IdCounter + 1! !

!ZnLogEvent class methodsFor: 'convenience' stamp: 'SvenVanCaekenberghe 6/11/2014 13:57'!
open
	^ self announcer open! !

!ZnLogEvent class methodsFor: 'system startup' stamp: 'SvenVanCaekenberghe 6/11/2014 13:57'!
startUp
	"Reset the id counter"
	
	IdCounter := 0! !

!ZnLogEvent class methodsFor: 'convenience' stamp: 'SvenVanCaekenberghe 3/18/2015 11:45'!
stopLoggingToTranscript
	self announcer unsubscribe: self! !

!ZnLogEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 13:58'!
announcer
	^ self class announcer! !

!ZnLogEvent methodsFor: 'actions' stamp: 'SvenVanCaekenberghe 6/11/2014 13:58'!
emit
	self announcer announce: self! !

!ZnLogEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 13:58'!
id
	^ id! !

!ZnLogEvent methodsFor: 'initialize' stamp: 'SvenVanCaekenberghe 7/1/2015 15:14'!
initialize
	super initialize.
	timestamp := DateAndTime now.
	id := self nextId! !

!ZnLogEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 14:04'!
nextId
	^ self class nextId! !

!ZnLogEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 16:52'!
printContentsOn: stream
	"Subclasses should implement this to add output"! !

!ZnLogEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 16:52'!
printOn: stream
	timestamp printYMDOn: stream.
	stream space.
	timestamp printHMSOn: stream. 
	stream space.
	id \\ 1000 printOn: stream base: 10 length: 3 padded: true.
	self printContentsOn: stream! !

!ZnLogEvent methodsFor: 'beacon' stamp: 'SvenVanCaekenberghe 6/30/2014 17:13'!
printOneLineContentsOn: stream
	self printContentsOn: stream! !

!ZnLogEvent methodsFor: 'beacon' stamp: 'SvenVanCaekenberghe 6/30/2014 17:13'!
printOneLineOn: stream
	self printOn: stream! !

!ZnLogEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 13:59'!
timestamp
	^ timestamp! !

ZnLogEvent subclass: #ZnServerLogEvent
	instanceVariableNames: 'serverId processId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnServerLogEvent commentStamp: 'SvenVanCaekenberghe 6/12/2014 15:27' prior: 0!
I am ZnServerLogEvent, a ZnLogEvent generated by ZnServer and its subclasses.

I hold a processId attribute.
I hold an optional serverId attribute.!

ZnServerLogEvent subclass: #ZnConnectionAcceptedEvent
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnConnectionAcceptedEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 15:04' prior: 0!
ZnConnectionAcceptedEvent is signalled when an HTTP server accepts an incoming connection from a client at address.!

!ZnConnectionAcceptedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 11:45'!
address
	^ address! !

!ZnConnectionAcceptedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 11:45'!
address: anObject
	address := anObject! !

!ZnConnectionAcceptedEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Connection Accepted '.
	address do: [ :each | stream print: each ] separatedBy: [ stream nextPut: $. ]! !

ZnServerLogEvent subclass: #ZnRequestReadEvent
	instanceVariableNames: 'request duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnRequestReadEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 15:07' prior: 0!
ZnRequestReadEvent is signalled when an HTTP server reads a request in duration milliseconds.

Note that the duration can be misleading: when servicing multiple requests over a kept alive connection (the default for HTTP 1.1), the read time includes any wait time (as long as it is below the timeout). The first request read should not contain wait time.!

!ZnRequestReadEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 14:55'!
duration
	^ duration! !

!ZnRequestReadEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 14:55'!
duration: anObject
	duration := anObject! !

!ZnRequestReadEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Request Read '; print: request; space; print: duration; << 'ms'! !

!ZnRequestReadEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 14:55'!
request
	^ request! !

!ZnRequestReadEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 14:55'!
request: anObject
	request := anObject! !

ZnServerLogEvent subclass: #ZnRequestResponseHandledEvent
	instanceVariableNames: 'request response duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnRequestResponseHandledEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 15:09' prior: 0!
ZnRequestResponseHandledEvent signals that the handler (delegate) processed a request and produced a response in duration in milliseconds. This duration is thus the time taken by the application itself.!

!ZnRequestResponseHandledEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 14:55'!
duration
	^ duration! !

!ZnRequestResponseHandledEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 14:55'!
duration: anObject
	duration := anObject! !

!ZnRequestResponseHandledEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Request Handled '; print: request; space; print: duration; << 'ms'! !

!ZnRequestResponseHandledEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 14:55'!
request
	^ request! !

!ZnRequestResponseHandledEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 14:55'!
request: anObject
	request := anObject! !

!ZnRequestResponseHandledEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 14:55'!
response
	^ response! !

!ZnRequestResponseHandledEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 14:55'!
response: anObject
	response := anObject! !

ZnServerLogEvent subclass: #ZnResponseWrittenEvent
	instanceVariableNames: 'response duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnResponseWrittenEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 15:09' prior: 0!
ZnResponseWrittenEvent signals that response was written in duration milliseconds.!

!ZnResponseWrittenEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 14:55'!
duration
	^ duration! !

!ZnResponseWrittenEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 14:55'!
duration: anObject
	duration := anObject! !

!ZnResponseWrittenEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Response Written '; print: response; space; print: duration; << 'ms'! !

!ZnResponseWrittenEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 14:55'!
response
	^ response! !

!ZnResponseWrittenEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 14:55'!
response: anObject
	response := anObject! !

ZnServerLogEvent subclass: #ZnServerConnectionClosedEvent
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnServerConnectionClosedEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 15:10' prior: 0!
ZnServerConnectionClosedEvent signals that the server closed a client connection to address. !

!ZnServerConnectionClosedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 13:28'!
address
	^ address! !

!ZnServerConnectionClosedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 13:28'!
address: anObject
	address := anObject! !

!ZnServerConnectionClosedEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Server Connection Closed '.
	address do: [ :each | stream print: each ] separatedBy: [ stream nextPut: $. ]! !

ZnServerLogEvent subclass: #ZnServerErrorEvent
	instanceVariableNames: 'exception'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnServerErrorEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 15:10' prior: 0!
ZnServerErrorEvent is a ZnServerLogEvent related to an exception that occurred.!

!ZnServerErrorEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 14:22'!
exception
	^ exception! !

!ZnServerErrorEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 14:22'!
exception: anObject
	exception := anObject! !

ZnServerErrorEvent subclass: #ZnServerHandlerErrorEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnServerHandlerErrorEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 15:12' prior: 0!
ZnServerHandlerErrorEvent signals an error that occurred during handling by the delegate. This is considered a real error.!

!ZnServerHandlerErrorEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Server Handler Error ';  print: exception! !

ZnServerErrorEvent subclass: #ZnServerReadErrorEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnServerReadErrorEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 15:13' prior: 0!
ZnServerReadErrorEvent signals an error during the reading of a request. These errors are considered mostly benign and the connection gets closed.
!

!ZnServerReadErrorEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Server Read Error ';  print: exception! !

ZnServerErrorEvent subclass: #ZnServerWriteErrorEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnServerWriteErrorEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 15:13' prior: 0!
ZnServerWriteErrorEvent signals an error during the writing of a response. These errors are considered mostly benign and the connection gets closed.
!

!ZnServerWriteErrorEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Server Write Error ';  print: exception! !

ZnServerLogEvent subclass: #ZnServerGenericLogEvent
	instanceVariableNames: 'subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnServerGenericLogEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 15:03' prior: 0!
I am ZnServerGenericLogEvent, a ZnServerLogEvent and ZnLogEvent that holds a generic subject, possibly not limited to a String.

Here are two examples:

(ZnServerGenericLogEvent subject: 'You can''t do that, Dave') emit.

(ZnServerGenericLogEvent subject: { #id->123. #reason->#timeout } asDictionary) emit.!

!ZnServerGenericLogEvent class methodsFor: 'instance creation' stamp: 'SvenVanCaekenberghe 6/16/2014 12:33'!
subject: object
	"self subject: #(i 10 j -1)."
	"self subject: 'How are you?'."
	
	^ self new
		subject: object;
		yourself! !

!ZnServerGenericLogEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 11/6/2014 15:10'!
printContentsOn: stream
	super printContentsOn: stream.
	stream space; nextPutAll: subject asString! !

!ZnServerGenericLogEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/16/2014 11:39'!
subject
	^ subject! !

!ZnServerGenericLogEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/16/2014 11:39'!
subject: anObject
	subject := anObject! !

!ZnServerLogEvent methodsFor: 'initialize' stamp: 'SvenVanCaekenberghe 6/11/2014 15:17'!
initialize
	super initialize.
	processId := ZnUtils currentProcessID! !

!ZnServerLogEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 11/6/2014 15:30'!
printContentsOn: stream
	super printContentsOn: stream.
	serverId ifNotNil: [ stream space; << serverId ].
	stream space.
	processId printOn: stream base: 10 length: 6 padded: true! !

!ZnServerLogEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:15'!
processId
	^ processId! !

!ZnServerLogEvent methodsFor: 'initialize' stamp: 'SvenVanCaekenberghe 6/11/2014 15:15'!
processId: anObject
	processId := anObject! !

!ZnServerLogEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/11/2014 15:15'!
serverId
	^ serverId! !

!ZnServerLogEvent methodsFor: 'initialize' stamp: 'SvenVanCaekenberghe 6/11/2014 15:15'!
serverId: anObject
	serverId := anObject! !

ZnServerLogEvent subclass: #ZnServerSocketBoundEvent
	instanceVariableNames: 'address port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnServerSocketBoundEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 15:14' prior: 0!
ZnServerSocketBoundEvent signals a new server socket on address:port is bound (opened).!

!ZnServerSocketBoundEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 11:10'!
address
	^ address! !

!ZnServerSocketBoundEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 11:10'!
address: anObject
	address := anObject! !

!ZnServerSocketBoundEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 11:10'!
port
	^ port! !

!ZnServerSocketBoundEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 11:10'!
port: anObject
	port := anObject! !

!ZnServerSocketBoundEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Server Socket Bound '.
	address do: [ :each | stream print: each ] separatedBy: [ stream nextPut: $. ].
	stream nextPut: $:; print: port
	! !

ZnServerLogEvent subclass: #ZnServerSocketReleasedEvent
	instanceVariableNames: 'address port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnServerSocketReleasedEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 15:14' prior: 0!
ZnServerSocketReleasedEvent signals a new server socket on address:port is released (closed).!

!ZnServerSocketReleasedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 13:32'!
address
	^ address! !

!ZnServerSocketReleasedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 13:32'!
address: anObject
	address := anObject! !

!ZnServerSocketReleasedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 13:32'!
port
	^ port! !

!ZnServerSocketReleasedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 13:32'!
port: anObject
	port := anObject! !

!ZnServerSocketReleasedEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Server Socket Released '.
	address do: [ :each | stream print: each ] separatedBy: [ stream nextPut: $. ].
	stream nextPut: $:; print: port! !

ZnServerLogEvent subclass: #ZnServerStartedEvent
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnServerStartedEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 15:14' prior: 0!
ZnServerStartedEvent notes the startup of an HTTP server is complete.
!

!ZnServerStartedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 10:54'!
description
	^ description! !

!ZnServerStartedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 10:54'!
description: anObject
	description := anObject! !

!ZnServerStartedEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Started '; << description! !

ZnServerLogEvent subclass: #ZnServerStoppedEvent
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnServerStoppedEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 15:15' prior: 0!
ZnServerStoppedEvent notes the shutdown of an HTTP server is complete.!

!ZnServerStoppedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 10:55'!
description
	^ description! !

!ZnServerStoppedEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 10:55'!
description: anObject
	description := anObject! !

!ZnServerStoppedEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream << ' Stopped '; << description! !

ZnServerLogEvent subclass: #ZnServerTransactionEvent
	instanceVariableNames: 'request response timing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnServerTransactionEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 15:18' prior: 0!
ZnServerTransactionEvent is a ZnServerLogEvent that notes the completion of a server side HTTP transaction (request/response).

Instance Variables
	request: a ZnRequest
	response:	a ZnResponse
	timing: a ZnServerTransactionTiming

Note that this can be quite large since it includes the entities transferred. See ZnSimplifiedServerTransactionEvent for a more compact representation.!

!ZnServerTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:03'!
duration
	^ timing totalDuration! !

!ZnServerTransactionEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream space.
	request requestLine printMethodAndUriOn: stream.
	stream space; print: response code.
	response hasEntity
		ifTrue: [ 
			stream space; print: response entity contentLength; nextPut: $B ].
	stream space; print: self duration; nextPutAll: 'ms'! !

!ZnServerTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:02'!
request
	^ request! !

!ZnServerTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:02'!
request: anObject
	request := anObject! !

!ZnServerTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:02'!
response
	^ response! !

!ZnServerTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:02'!
response: anObject
	response := anObject! !

!ZnServerTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:02'!
timing
	^ timing! !

!ZnServerTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:02'!
timing: anObject
	timing := anObject! !

ZnServerLogEvent subclass: #ZnSimplifiedServerTransactionEvent
	instanceVariableNames: 'method url response size duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnSimplifiedServerTransactionEvent commentStamp: 'SvenVanCaekenberghe 6/16/2014 15:20' prior: 0!
ZnSimplifiedServerTransactionEvent is a ZnServerLogEvent that notes the completion of a served side HTTP transaction (request/response). Only a limited number of simpler data is held. ZnServerTransactionEvent contains much more detailed data.

Instance Variables
	method: HTTP verb
	url: ZnUrl requested
	response:	numeric response code
	size: number of bytes in response
	duration: milliseconds

ZnSimplifiedServerTransactionEvent is ideal for classic HTTP logging with little overhead through its default string representation.
!

!ZnSimplifiedServerTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:58'!
duration
	^ duration! !

!ZnSimplifiedServerTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:58'!
method
	^ method! !

!ZnSimplifiedServerTransactionEvent methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/30/2014 17:06'!
printContentsOn: stream
	super printContentsOn: stream.
	stream space; nextPutAll: method.
	stream space.
	url printPathQueryFragmentOn: stream.
	stream space; print: response.
	size ifNotNil: [ 
		stream space; print: size; nextPut: $B ].
	stream space; print: duration; nextPutAll: 'ms'! !

!ZnSimplifiedServerTransactionEvent methodsFor: 'initialize' stamp: 'SvenVanCaekenberghe 6/13/2014 16:57'!
request: aZnRequest
	method := aZnRequest method.
	url := aZnRequest url! !

!ZnSimplifiedServerTransactionEvent methodsFor: 'initialize' stamp: 'SvenVanCaekenberghe 6/13/2014 16:57'!
response: aZnResponse
	response := aZnResponse code.
	aZnResponse hasEntity
		ifTrue: [ size := aZnResponse entity contentLength ]! !

!ZnSimplifiedServerTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:58'!
responseCode
	^ response! !

!ZnSimplifiedServerTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:58'!
size
	^ size! !

!ZnSimplifiedServerTransactionEvent methodsFor: 'initialize' stamp: 'SvenVanCaekenberghe 6/13/2014 16:56'!
timing: timing
	duration := timing totalDuration ! !

!ZnSimplifiedServerTransactionEvent methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:58'!
url
	^ url! !

Object subclass: #ZnCommonLogFormat
	instanceVariableNames: 'combined'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnCommonLogFormat commentStamp: 'SvenVanCaekenberghe 7/1/2015 16:34' prior: 0!
I am ZnCommonLogFormat, I can output ZnServerTransactionEvent objects using Apache Common Log Format (CLF).

https://en.wikipedia.org/wiki/Common_Log_Format
https://httpd.apache.org/docs/trunk/logs.html#common

| formatter |
formatter := ZnCommonLogFormat new.
ZnLogEvent announcer 
  when: ZnServerTransactionEvent 
  do: [ :event | 
    formatter format: event on: Transcript.
    Transcript cr; endEntry ].
!

!ZnCommonLogFormat methodsFor: 'private' stamp: 'SvenVanCaekenberghe 7/1/2015 16:31'!
clientIPAddressFrom: event
	^ event request headers 
		at: ZnConstants remoteAddressHeader 
		ifAbsent: [ '-' ]! !

!ZnCommonLogFormat methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/1/2015 14:22'!
combined
	^ combined! !

!ZnCommonLogFormat methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/1/2015 16:24'!
combined: boolean
	"If boolean is true (the default), use the 'Combined' format, 
	adding Referer and User-Agent fields."
	
	combined := boolean! !

!ZnCommonLogFormat methodsFor: 'public' stamp: 'SvenVanCaekenberghe 7/1/2015 16:34'!
format: event on: stream
	"Output a ZnServerTransactionEvent on a text stream in Common Log Format"
	
	stream << (self clientIPAddressFrom: event); << ' - '.
	stream << (self userFrom: event); space.
	self formatTimestamp: event timestamp on: stream.
	self formatRequest: event on: stream.
	self formatResponse: event on: stream. 
	combined ifTrue: [ self formatCombinedFields: event request on: stream ]! !

!ZnCommonLogFormat methodsFor: 'private' stamp: 'SvenVanCaekenberghe 7/1/2015 16:09'!
formatCombinedFields: request on: stream
	| referer userAgent |
	referer := request headers at: 'Referer' ifAbsent: [ '-' ].
	userAgent := request headers at: 'User-Agent' ifAbsent: [ '-' ].
	stream space.
	stream nextPut: $"; << referer; nextPut: $".
	stream space.
	stream nextPut: $"; << userAgent; nextPut: $"
! !

!ZnCommonLogFormat methodsFor: 'private' stamp: 'SvenVanCaekenberghe 7/1/2015 16:30'!
formatRequest: event on: stream
	| requestLine |
	stream space.
	requestLine := event request requestLine.
	stream << $".
	requestLine printMethodAndUriOn: stream.
	stream space; << requestLine version.
	stream << $"! !

!ZnCommonLogFormat methodsFor: 'private' stamp: 'SvenVanCaekenberghe 7/1/2015 16:30'!
formatResponse: event on: stream
	| size |
	stream space.
	stream print: event response code.
	stream space.
	size := event response hasEntity 
		ifTrue: [ event response contentLength ] 
		ifFalse: [ 0 ].
	stream print: size
! !

!ZnCommonLogFormat methodsFor: 'private' stamp: 'SvenVanCaekenberghe 7/1/2015 15:35'!
formatTimestamp: timestamp on: stream
	stream nextPut: $[.
	timestamp dayOfMonth printOn: stream base: 10 length: 2 padded: true.
	stream nextPut: $/.
	stream << timestamp monthAbbreviation.
	stream nextPut: $/.
	timestamp year printOn: stream.
	stream << $:.
	timestamp printHMSOn: stream.
	stream space.
	stream nextPut: (timestamp offset positive ifTrue: [ $+ ] ifFalse: [ $- ]).
	timestamp offset hours abs printOn: stream base: 10 length: 2 padded: true.
	stream nextPut: $:.
	timestamp offset minutes abs printOn: stream base: 10 length: 2 padded: true.
	stream nextPut: $]! !

!ZnCommonLogFormat methodsFor: 'initialize' stamp: 'SvenVanCaekenberghe 7/1/2015 14:22'!
initialize
	super initialize.
	combined := true.! !

!ZnCommonLogFormat methodsFor: 'private' stamp: 'SvenVanCaekenberghe 7/1/2015 16:31'!
userFrom: event
	^ [ event request basicAuthentication first ]
		on: Error
		do: [ '-' ]! !

Object subclass: #ZnServerTransactionTiming
	instanceVariableNames: 'requestDuration handlerDuration responseDuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZincHTTPLoggingGemStone'!

!ZnServerTransactionTiming commentStamp: 'SvenVanCaekenberghe 6/13/2014 16:00' prior: 0!
I am ZnServerTransactionTiming.

I hold timing information related to the handling of an HTTP transaction by a server.
!

!ZnServerTransactionTiming methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:00'!
handlerDuration
	^ handlerDuration! !

!ZnServerTransactionTiming methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:00'!
handlerDuration: anObject
	handlerDuration := anObject! !

!ZnServerTransactionTiming methodsFor: 'initialize' stamp: 'SvenVanCaekenberghe 6/13/2014 16:01'!
initialize
	super initialize.
	requestDuration := handlerDuration := responseDuration := 0! !

!ZnServerTransactionTiming methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:00'!
requestDuration
	^ requestDuration! !

!ZnServerTransactionTiming methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:00'!
requestDuration: anObject
	requestDuration := anObject! !

!ZnServerTransactionTiming methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:00'!
responseDuration
	^ responseDuration! !

!ZnServerTransactionTiming methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 16:00'!
responseDuration: anObject
	responseDuration := anObject! !

!ZnServerTransactionTiming methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/13/2014 21:49'!
totalDuration
	"requestDuration is unreliable because it contains idle wait time"
	
	^ handlerDuration + responseDuration ! !

ZnLogEvent initialize!
